/*
 * RiskScape™ Copyright New Zealand Institute for Earth Science Limited
 * (Earth Sciences New Zealand) is distributed for research purposes only
 * under the terms of AGPLv3.
 *
 * RiskScape™ Copyright 2026 New Zealand Institute for Earth Science
 * Limited (Earth Sciences New Zealand). All rights reserved. Source code
 * available under the AGPLv3.
 * 
 * This program is free software: you can redistribute it and/or modify it under
 *  the terms of the GNU Affero General Public License as published by the Free
 *  Software Foundation, either version 3 of the License, or (at your option) any
 *  later version.
 * 
 * This program is distributed for RESEARCH PURPOSES ONLY, in the hope that it will
 * be useful for research and education initiatives.
 * 
 * If you are not a researcher, or you are a researcher who wishes to use this
 * program on terms other than AGPLv3 (including those who wish to restrict the
 * distribution of any source code created using this program), please contact:
 * https://riskscape.org.nz
 * 
 * This program is distributed WITHOUT ANY WARRANTY; without even the implied
 * warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Affero General Public License for more details.  You should have received a copy
 * of the GNU Affero General Public License along with this program.  If not, see
 * <http://www.gnu.org/licenses/>.
 * 
 * By way of summary only, under the AGPLv3:
 *     • Permissions of this strongest copyleft license are conditioned
 *       on making available complete source code of licensed works and
 *       modifications, which include larger works using a licensed work,
 *       under the same license.
 *     • Copyright and license notices must be preserved.
 *     • Contributors provide an express grant of patent rights.
 *     • When a modified version is used to provide a service over a
 *       network, the complete source code of the modified version must be made
 *       available.
 */
package nz.org.riskscape.engine.relation;

import static org.junit.Assert.*;

import java.util.Optional;

import org.geotools.geometry.Position2D;
import org.geotools.geometry.jts.JTS;
import org.geotools.geometry.jts.ReferencedEnvelope;
import org.junit.Test;

import org.locationtech.jts.geom.Envelope;
import org.locationtech.jts.geom.Geometry;
import org.locationtech.jts.geom.GeometryFactory;

import nz.org.riskscape.engine.ProjectTest;
import nz.org.riskscape.engine.Tuple;
import nz.org.riskscape.engine.types.Nullable;
import nz.org.riskscape.engine.types.Struct;
import nz.org.riskscape.engine.types.Types;

/**
 * Does some tests on BaseRelation and Relation via the simple {@link ListRelation} class
 */
public class RelationTest extends ProjectTest {

  GeometryFactory gf = project.getSridSet().getGeometryFactory(project.getDefaultCrs());
  Struct type = Struct.of("geom", Types.GEOMETRY);

  @Test
  public void boundsIsEmptyWhenNoSpatialMetadata() {
    assertFalse(new ListRelation(type).calculateBounds().isPresent());
  }

  @Test
  public void boundsIsEmptyWhenNoTuples() {
    assertFalse(new ListRelation(type).inferSpatialMetadata(project).calculateBounds().isPresent());
  }

  @Test
  public void boundsIsTheSizeOfTheSingleMembersBounds() throws Exception {
    Geometry g = JTS.toGeometry(new Envelope(5, 20, 10, 30), gf);
    Optional<ReferencedEnvelope> bounds =
        new ListRelation(Tuple.ofValues(type, g)).inferSpatialMetadata(project).calculateBounds();

    assertTrue(bounds.isPresent());
    assertEquals(new ReferencedEnvelope(5, 20, 10, 30, project.getDefaultCrs()), bounds.get());
  }

  @Test
  public void boundsAccommodatesAllOfTheThingsBounds() throws Exception {
    Geometry g1 = JTS.toGeometry(new Position2D(5, 5), gf);
    Geometry g2 = JTS.toGeometry(new Position2D(-4, -10), gf);

    ListRelation relation = new ListRelation(
      Tuple.ofValues(type, g1),
      Tuple.ofValues(type, g2)
    ).inferSpatialMetadata(project);

    Optional<ReferencedEnvelope> bounds = relation.calculateBounds();

    assertTrue(bounds.isPresent());
    assertEquals(new ReferencedEnvelope(-4, 5, -10, 5, project.getDefaultCrs()), bounds.get());
  }

  @Test
  public void boundsAccomodatesNullGeometries() throws Exception {
    type = Struct.of("geom", Nullable.GEOMETRY);
    Geometry g1 = JTS.toGeometry(new Position2D(5, 5), gf);
    Geometry g2 = JTS.toGeometry(new Position2D(-4, -10), gf);

    ListRelation relation = new ListRelation(
      Tuple.ofValues(type, g1),
      Tuple.ofValues(type),
      Tuple.ofValues(type, g2)
    ).inferSpatialMetadata(project);

    Optional<ReferencedEnvelope> bounds = relation.calculateBounds();

    assertTrue(bounds.isPresent());
    assertEquals(new ReferencedEnvelope(-4, 5, -10, 5, project.getDefaultCrs()), bounds.get());
  }

}
